/*		

	Qubec ; 
	
	Version / 29 septembre 2010.

*/

// -------------------------------------------------------------------------------------------------------------

#include "ext.h"							
#include "ext_obex.h"
#include "jpatcher_api.h"
	
// -------------------------------------------------------------------------------------------------------------

typedef struct _quebec {
	t_object		ob ;
	t_object		*mypatcher ;			
	t_object		*myfirstview ;
	void			*m_out1 ;
	void			*m_out2	;
	} t_quebec ;
	
// -------------------------------------------------------------------------------------------------------------	
	
void *quebec_new		(t_symbol *s, long argc, t_atom *argv) ;
void quebec_free		(t_quebec *x) ;
void quebec_assist		(t_quebec *x, void *b, long m, long a, char *s) ;
void quebec_bang		(t_quebec *x) ;

void quebec_attach		(t_quebec *x) ;
void quebec_notify		(t_quebec *x, t_symbol *s, t_symbol *msg, void *sender, void *data) ;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

static t_class *quebec_class ;

int main (void)
	{	
		t_class *c = NULL ;
		
		c = class_new ("quebec", (method)quebec_new, (method)quebec_free, (long)sizeof(t_quebec), 0L, A_GIMME, 0) ;
		
		class_addmethod (c, (method)quebec_assist,	"assist", A_CANT, 0) ;
		class_addmethod (c, (method)quebec_notify,	"notify", A_CANT, 0) ; 
		class_addmethod (c, (method)quebec_bang,	"bang", 0) ; 

		class_register (CLASS_BOX, c) ; 
		
		quebec_class = c ;
		
		return 0 ;
	}

void *quebec_new (t_symbol *s, long argc, t_atom *argv)
	{
		t_quebec *x = NULL;
		
		if (x = (t_quebec *)object_alloc (quebec_class)) 
			{		
				x->mypatcher		= NULL ;
				x->myfirstview		= NULL ;
				
				x->m_out2 = intout	((t_object *)x) ;
				x->m_out1 = bangout ((t_object *)x) ;
			}
				
		return x ;
	}

void quebec_free (t_quebec *x)
	{ 
		if (x->myfirstview) 
			{
				object_detach_byptr (x, x->myfirstview) ;
			}
	}

void quebec_assist (t_quebec *x, void *b, long m, long a, char *s)
	{
		if (m == ASSIST_INLET) 
			{ 
				sprintf (s, "(bang) attach to patcher") ;
			} 
		else 
			{	
				if (a == 0)
					{
						sprintf (s, "(bang) When Resized") ;	
					}
				else
					{
						sprintf (s, "(int) Is locked") ;
					}
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void quebec_bang (t_quebec *x)
	{
		if (!x->myfirstview)
			{
				object_obex_lookup (x, gensym ("#P"), &x->mypatcher) ;				
				defer_low (x, (method)quebec_attach, NULL, 0, NULL) ;
			}
	}

void quebec_attach (t_quebec *x)
	{	
		if (x->myfirstview = object_attr_getobj (x->mypatcher, gensym ("firstview")))
			{
				object_attach_byptr_register (x, x->myfirstview, CLASS_NOBOX) ;
				outlet_int (x->m_out2, patcherview_get_locked (x->myfirstview)) ;
			}
	}
	
void quebec_notify (t_quebec *x, t_symbol *s, t_symbol *msg, void *sender, void *data)
	{
		if (msg == gensym ("attr_modified") && sender == x->myfirstview) 
			{ 			
				t_symbol *attr_name = NULL ;
				
				attr_name = (t_symbol *)object_method (data, gensym ("getname")) ;				
				
				if (attr_name == gensym ("locked"))
					{
						outlet_int (x->m_out2, patcherview_get_locked (x->myfirstview)) ;
					}
					
				if (attr_name == gensym ("rect"))
					{
						outlet_bang (x->m_out1) ;
					}
			}
	}
	
// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x